=== debian/changelog ===
arpack (3.9.1-6) unstable; urgency=medium

  * Team upload.
  * add powerpc to the !arch lists in debian/libparpack2t64.symbols

 -- Drew Parsons <dparsons@debian.org>  Fri, 04 Apr 2025 23:53:53 +0200

arpack (3.9.1-5) unstable; urgency=medium

  * Team upload.
  * debian patch parpack_icb_skip_failing_arch.patch skips PARPACK ICB
    tests on powerpc
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Fri, 04 Apr 2025 20:42:22 +0200

arpack (3.9.1-4) unstable; urgency=medium

  * Team upload.
  * don't provide 64-bit build for 32-bit arches
    since blas64 is not available there

 -- Drew Parsons <dparsons@debian.org>  Thu, 05 Dec 2024 18:36:25 +0100

arpack (3.9.1-3) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Thu, 05 Dec 2024 13:36:21 +0100

arpack (3.9.1-2) experimental; urgency=medium

  * Team upload.
  * libarpack64-2-dev provides 64-bit arpack (INTERFACE64=1)
    linking to 64-bit BLAS/LAPACK. Closes: #972068.
    Note that parpack does not support 64-bit integers (ILP64).

 -- Drew Parsons <dparsons@debian.org>  Thu, 28 Nov 2024 21:17:38 +0100

arpack (3.9.1-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Unlist some symbols from armel, armhf, i386 and hurd-i386, which now
    build against MPICH. Closes: #1076468.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Wed, 20 Nov 2024 14:36:36 +0100

arpack (3.9.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061919

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 01:45:44 +0000

arpack (3.9.1-1) unstable; urgency=medium

  * New upstream release
  * Bring back the install of cmake files
  * New symbols
    + ccdotc_@Base
    + zzdotc_@Base

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 14 Oct 2023 14:10:25 +0200
