=== debian/control ===
--- 
+++ 
@@ -3,19 +3,25 @@
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>
 Section: math
 Priority: optional
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
                gfortran,
+               cmake,
                libblas-dev,
                liblapack-dev,
+               libblas64-dev [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32],
+               liblapack64-dev [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32],
                mpi-default-dev,
                libeigen3-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/science-team/arpack
 Vcs-Git: https://salsa.debian.org/science-team/arpack.git
 Homepage: https://github.com/opencollab/arpack-ng
 Rules-Requires-Root: no
 
-Package: libarpack2
+Package: libarpack2t64
+Provides: ${t64:Provides}
+Replaces: libarpack2
+Breaks: libarpack2 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -52,7 +58,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libarpack2 (= ${binary:Version}),
+Depends: libarpack2t64 (= ${binary:Version}),
          libblas-dev | libblas.so,
          liblapack-dev | liblapack.so,
          ${misc:Depends}
@@ -70,7 +76,10 @@
  This package contains the static libraries and the documentation for
  development with libarpack (including examples).
 
-Package: libparpack2
+Package: libparpack2t64
+Provides: ${t64:Provides}
+Replaces: libparpack2
+Breaks: libparpack2 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -109,7 +118,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libparpack2 (= ${binary:Version}),
+Depends: libparpack2t64 (= ${binary:Version}),
          libblas-dev | libblas.so,
          liblapack-dev | liblapack.so,
          mpi-default-dev,
@@ -127,3 +136,58 @@
  .
  This package contains the static libraries and the documentation for
  development with libparpack (including examples).
+
+Package: libarpack64-2
+Architecture: any
+Multi-Arch: same
+Section: libs
+Depends: ${shlibs:Depends},
+         ${misc:Depends}
+Description: Fortran77 subroutines to solve large scale eigenvalue problems
+ ARPACK software is capable of solving large scale symmetric,
+ nonsymmetric, and generalized eigenproblems from significant
+ application areas. The software is designed to compute a few (k)
+ eigenvalues with user specified features such as those of largest
+ real part or largest magnitude. Storage requirements are on the order
+ of n*k locations. No auxiliary storage is required. A set of Schur
+ basis vectors for the desired k-dimensional eigen-space is computed
+ which is numerically orthogonal to working precision. Numerically
+ accurate eigenvectors are available on request.
+ .
+ Important Features:
+ .
+  * Reverse Communication Interface.
+  * Single and Double Precision Real Arithmetic Versions for Symmetric,
+    Non-symmetric,
+  * Standard or Generalized Problems.
+  * Single and Double Precision Complex Arithmetic Versions for Standard or
+    Generalized Problems.
+  * Routines for Banded Matrices - Standard or Generalized Problems.
+  * Routines for The Singular Value Decomposition.
+  * Example driver routines that may be used as templates to implement
+    numerous Shift-Invert strategies for all problem types, data types and
+    precision.
+ .
+ This package contains the shared library with 64-bit integers.
+
+Package: libarpack64-2-dev
+Architecture: any
+Multi-Arch: same
+Section: libdevel
+Depends: libarpack64-2 (= ${binary:Version}),
+         libblas64-dev | libblas64.so,
+         liblapack64-dev | liblapack64.so,
+         ${misc:Depends}
+Description: Fortran77 subroutines to solve large scale eigenvalue problems (development)
+ ARPACK software is capable of solving large scale symmetric,
+ nonsymmetric, and generalized eigenproblems from significant
+ application areas. The software is designed to compute a few (k)
+ eigenvalues with user specified features such as those of largest
+ real part or largest magnitude. Storage requirements are on the order
+ of n*k locations. No auxiliary storage is required. A set of Schur
+ basis vectors for the desired k-dimensional eigen-space is computed
+ which is numerically orthogonal to working precision. Numerically
+ accurate eigenvectors are available on request.
+ .
+ This package contains the static libraries and the documentation for
+ development with libarpack (including examples) with 64-bit integers.
