=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# no 64-bit build for 32-bit arches since blas64 is not available there
ifneq (64,$(DEB_HOST_ARCH_BITS))
export DH_OPTIONS = \
    -Nlibarpack64-2-dev \
    -Nlibarpack64-2
endif

%:
	dh $@

execute_after_dh_auto_clean:
	rm -rf build build64

override_dh_auto_configure:
	# Enforce generic BLAS (to avoid tying to ATLAS or OpenBLAS)
	dh_auto_configure -B build --  --enable-mpi --with-blas=blas --enable-icb --enable-static
	
ifeq (64,$(DEB_HOST_ARCH_BITS))
	# disable MPI for 64-bit build: parpack does not support 64 bits
	INTERFACE64="1" ITF64SUFFIX="64" dh_auto_configure -B build64 --  --disable-mpi --with-blas=blas64 --with-lapack=lapack64 --enable-icb --enable-static
endif

override_dh_auto_build:
	dh_auto_build -B build
ifeq (64,$(DEB_HOST_ARCH_BITS))
	dh_auto_build -B build64
endif

override_dh_auto_test:
	# Disable fakeroot for parallel tests because of https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=839387
	env -u LD_PRELOAD dh_auto_test -B build
ifeq (64,$(DEB_HOST_ARCH_BITS))
	dh_auto_test -B build64
endif

override_dh_auto_install:
	dh_auto_install -B build
ifeq (64,$(DEB_HOST_ARCH_BITS))
	dh_auto_install -B build64
endif
